/*
 * CameraException.cpp
 *
 *  Created on: Jul 28, 2010
 *      Author: petrito1@cmp.felk.cvut.cz
 */

#include "CameraException.h"

namespace nifti {
namespace dc1394 {

CameraException::CameraException(dc1394error_t err, std::string msg) :
  std::runtime_error(msg), error(err) {
}

CameraException::CameraException() :
  std::runtime_error("Camera exception."), error(DC1394_SUCCESS) {
}

CameraException::~CameraException() throw () {
}

dc1394error_t CameraException::getError() {
  return this->error;
}

std::string CameraException::getErrorString() {
  return std::string(dc1394_error_get_string(this->error));
}

}
}
