/*
 * ioctl_open.cpp
 *
 *  Created on: Dec 27, 2010
 *      Author: petrito1
 */

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>

#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>

// Could not find VIDEO1394_IOC_UNLISTEN_CHANNEL definition anywhere...
//#include <ieee1394/video1394.h>
//#include <linux/firewire-cdev.h>
// Using inline definition from http://lxr.free-electrons.com/source/drivers/ieee1394/ieee1394-ioctl.h#L47
#define VIDEO1394_IOC_UNLISTEN_CHANNEL _IOW('#', 0x11, int)

int main(int argc, char **argv) {

  if (argc < 3) {
    printf("Not enough arguments.\n");
    printf("Usage: ioctl_open <device> <channel>\n");
    printf(" device - the video1394 character device driver (by default \"/dev/video1394/0\" if your host card is port 0)\n");
    printf(" channel - the IEEE 1394 ISO channel previously allocated to the camera (usually numbered from 0 on each host)\n");
    printf("Example: ioctl_open /dev/video1394/0 0\n");
    return -1;
  }

  char* device = argv[1];
  int channel = atoi(argv[2]);
  printf("Calling ioctl(open(%s, O_RDONLY), VIDEO1394_IOC_UNLISTEN_CHANNEL, %d)...\n", device, channel);

  ioctl(open(device, O_RDONLY), VIDEO1394_IOC_UNLISTEN_CHANNEL, channel);
}

